------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
limited with Qt4.Actions;
with Qt4.Icons;
with Qt4.Points;
with Qt4.Rects;
with Qt4.Strings;
with Qt4.Widgets;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Menus is

   type Q_Menu is limited interface
     and Qt4.Widgets.Q_Widget;

   type Q_Menu_Access is
     access all Q_Menu'Class;
   for Q_Menu_Access'Storage_Size use 0;

   type Q_Menu_Pointer is tagged;

   function Action_At
    (Self : not null access constant Q_Menu'Class;
     Pt : Qt4.Points.Q_Point)
       return not null access Qt4.Actions.Q_Action'Class;

   function Action_Geometry
    (Self : not null access constant Q_Menu'Class;
     Act : not null access Qt4.Actions.Q_Action'Class)
       return Qt4.Rects.Q_Rect;

   function Add_Action
    (Self : not null access Q_Menu'Class;
     Text : Qt4.Strings.Q_String)
       return not null access Qt4.Actions.Q_Action'Class;

   function Add_Action
    (Self : not null access Q_Menu'Class;
     Icon : Qt4.Icons.Q_Icon;
     Text : Qt4.Strings.Q_String)
       return not null access Qt4.Actions.Q_Action'Class;

   function Add_Menu
    (Self : not null access Q_Menu'Class;
     Menu : not null access Qt4.Menus.Q_Menu'Class)
       return not null access Qt4.Actions.Q_Action'Class;

   function Add_Menu
    (Self : not null access Q_Menu'Class;
     Text : Qt4.Strings.Q_String)
       return not null access Qt4.Menus.Q_Menu'Class;

   function Add_Menu
    (Self : not null access Q_Menu'Class;
     Icon : Qt4.Icons.Q_Icon;
     Text : Qt4.Strings.Q_String)
       return not null access Qt4.Menus.Q_Menu'Class;

   function Add_Separator
    (Self : not null access Q_Menu'Class)
       return not null access Qt4.Actions.Q_Action'Class;

   procedure Clear
    (Self : not null access Q_Menu'Class);

   function Default_Action
    (Self : not null access Q_Menu'Class)
       return not null access Qt4.Actions.Q_Action'Class;

   function Exec
    (Self : not null access Q_Menu'Class)
       return not null access Qt4.Actions.Q_Action'Class;

   procedure Hide_Tear_Off_Menu
    (Self : not null access Q_Menu'Class);

   function Icon
    (Self : not null access constant Q_Menu'Class)
       return Qt4.Icons.Q_Icon;

   function Insert_Menu
    (Self : not null access Q_Menu'Class;
     Before : not null access Qt4.Actions.Q_Action'Class;
     Menu : not null access Qt4.Menus.Q_Menu'Class)
       return not null access Qt4.Actions.Q_Action'Class;

   function Insert_Separator
    (Self : not null access Q_Menu'Class;
     Before : not null access Qt4.Actions.Q_Action'Class)
       return not null access Qt4.Actions.Q_Action'Class;

   function Is_Empty
    (Self : not null access constant Q_Menu'Class)
       return Standard.Boolean;

   function Is_Tear_Off_Enabled
    (Self : not null access constant Q_Menu'Class)
       return Standard.Boolean;

   function Is_Tear_Off_Menu_Visible
    (Self : not null access constant Q_Menu'Class)
       return Standard.Boolean;

   function Menu_Action
    (Self : not null access constant Q_Menu'Class)
       return not null access Qt4.Actions.Q_Action'Class;

   function Separators_Collapsible
    (Self : not null access constant Q_Menu'Class)
       return Standard.Boolean;

   procedure Set_Active_Action
    (Self : not null access Q_Menu'Class;
     Act : not null access Qt4.Actions.Q_Action'Class);

   procedure Set_Default_Action
    (Self : not null access Q_Menu'Class;
     Act : not null access Qt4.Actions.Q_Action'Class);

   procedure Set_Icon
    (Self : not null access Q_Menu'Class;
     Icon : Qt4.Icons.Q_Icon);

   procedure Set_Separators_Collapsible
    (Self : not null access Q_Menu'Class;
     Collapse : Standard.Boolean);

   procedure Set_Tear_Off_Enabled
    (Self : not null access Q_Menu'Class;
     Enable : Standard.Boolean);

   procedure Set_Title
    (Self : not null access Q_Menu'Class;
     Title : Qt4.Strings.Q_String);

   function Title
    (Self : not null access constant Q_Menu'Class)
       return Qt4.Strings.Q_String;

   package Q_Menu_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Menu, Q_Menu_Access);

   type Q_Menu_Pointer is
     new Q_Menu_Pointers.Q_Pointer with null record;

end Qt4.Menus;
